"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1UpdateOriginEndpointCommand = exports.deserializeAws_restJson1UpdateChannelCommand = exports.deserializeAws_restJson1UntagResourceCommand = exports.deserializeAws_restJson1TagResourceCommand = exports.deserializeAws_restJson1RotateIngestEndpointCredentialsCommand = exports.deserializeAws_restJson1RotateChannelCredentialsCommand = exports.deserializeAws_restJson1ListTagsForResourceCommand = exports.deserializeAws_restJson1ListOriginEndpointsCommand = exports.deserializeAws_restJson1ListHarvestJobsCommand = exports.deserializeAws_restJson1ListChannelsCommand = exports.deserializeAws_restJson1DescribeOriginEndpointCommand = exports.deserializeAws_restJson1DescribeHarvestJobCommand = exports.deserializeAws_restJson1DescribeChannelCommand = exports.deserializeAws_restJson1DeleteOriginEndpointCommand = exports.deserializeAws_restJson1DeleteChannelCommand = exports.deserializeAws_restJson1CreateOriginEndpointCommand = exports.deserializeAws_restJson1CreateHarvestJobCommand = exports.deserializeAws_restJson1CreateChannelCommand = exports.deserializeAws_restJson1ConfigureLogsCommand = exports.serializeAws_restJson1UpdateOriginEndpointCommand = exports.serializeAws_restJson1UpdateChannelCommand = exports.serializeAws_restJson1UntagResourceCommand = exports.serializeAws_restJson1TagResourceCommand = exports.serializeAws_restJson1RotateIngestEndpointCredentialsCommand = exports.serializeAws_restJson1RotateChannelCredentialsCommand = exports.serializeAws_restJson1ListTagsForResourceCommand = exports.serializeAws_restJson1ListOriginEndpointsCommand = exports.serializeAws_restJson1ListHarvestJobsCommand = exports.serializeAws_restJson1ListChannelsCommand = exports.serializeAws_restJson1DescribeOriginEndpointCommand = exports.serializeAws_restJson1DescribeHarvestJobCommand = exports.serializeAws_restJson1DescribeChannelCommand = exports.serializeAws_restJson1DeleteOriginEndpointCommand = exports.serializeAws_restJson1DeleteChannelCommand = exports.serializeAws_restJson1CreateOriginEndpointCommand = exports.serializeAws_restJson1CreateHarvestJobCommand = exports.serializeAws_restJson1CreateChannelCommand = exports.serializeAws_restJson1ConfigureLogsCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const MediaPackageServiceException_1 = require("../models/MediaPackageServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1ConfigureLogsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}/configure_logs";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    body = JSON.stringify({
        ...(input.EgressAccessLogs !== undefined &&
            input.EgressAccessLogs !== null && {
            egressAccessLogs: serializeAws_restJson1EgressAccessLogs(input.EgressAccessLogs, context),
        }),
        ...(input.IngressAccessLogs !== undefined &&
            input.IngressAccessLogs !== null && {
            ingressAccessLogs: serializeAws_restJson1IngressAccessLogs(input.IngressAccessLogs, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ConfigureLogsCommand = serializeAws_restJson1ConfigureLogsCommand;
const serializeAws_restJson1CreateChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels";
    let body;
    body = JSON.stringify({
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
        ...(input.Id !== undefined && input.Id !== null && { id: input.Id }),
        ...(input.Tags !== undefined && input.Tags !== null && { tags: serializeAws_restJson1Tags(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateChannelCommand = serializeAws_restJson1CreateChannelCommand;
const serializeAws_restJson1CreateHarvestJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/harvest_jobs";
    let body;
    body = JSON.stringify({
        ...(input.EndTime !== undefined && input.EndTime !== null && { endTime: input.EndTime }),
        ...(input.Id !== undefined && input.Id !== null && { id: input.Id }),
        ...(input.OriginEndpointId !== undefined &&
            input.OriginEndpointId !== null && { originEndpointId: input.OriginEndpointId }),
        ...(input.S3Destination !== undefined &&
            input.S3Destination !== null && {
            s3Destination: serializeAws_restJson1S3Destination(input.S3Destination, context),
        }),
        ...(input.StartTime !== undefined && input.StartTime !== null && { startTime: input.StartTime }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateHarvestJobCommand = serializeAws_restJson1CreateHarvestJobCommand;
const serializeAws_restJson1CreateOriginEndpointCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/origin_endpoints";
    let body;
    body = JSON.stringify({
        ...(input.Authorization !== undefined &&
            input.Authorization !== null && {
            authorization: serializeAws_restJson1Authorization(input.Authorization, context),
        }),
        ...(input.ChannelId !== undefined && input.ChannelId !== null && { channelId: input.ChannelId }),
        ...(input.CmafPackage !== undefined &&
            input.CmafPackage !== null && {
            cmafPackage: serializeAws_restJson1CmafPackageCreateOrUpdateParameters(input.CmafPackage, context),
        }),
        ...(input.DashPackage !== undefined &&
            input.DashPackage !== null && { dashPackage: serializeAws_restJson1DashPackage(input.DashPackage, context) }),
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
        ...(input.HlsPackage !== undefined &&
            input.HlsPackage !== null && { hlsPackage: serializeAws_restJson1HlsPackage(input.HlsPackage, context) }),
        ...(input.Id !== undefined && input.Id !== null && { id: input.Id }),
        ...(input.ManifestName !== undefined && input.ManifestName !== null && { manifestName: input.ManifestName }),
        ...(input.MssPackage !== undefined &&
            input.MssPackage !== null && { mssPackage: serializeAws_restJson1MssPackage(input.MssPackage, context) }),
        ...(input.Origination !== undefined && input.Origination !== null && { origination: input.Origination }),
        ...(input.StartoverWindowSeconds !== undefined &&
            input.StartoverWindowSeconds !== null && { startoverWindowSeconds: input.StartoverWindowSeconds }),
        ...(input.Tags !== undefined && input.Tags !== null && { tags: serializeAws_restJson1Tags(input.Tags, context) }),
        ...(input.TimeDelaySeconds !== undefined &&
            input.TimeDelaySeconds !== null && { timeDelaySeconds: input.TimeDelaySeconds }),
        ...(input.Whitelist !== undefined &&
            input.Whitelist !== null && { whitelist: serializeAws_restJson1__listOf__string(input.Whitelist, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateOriginEndpointCommand = serializeAws_restJson1CreateOriginEndpointCommand;
const serializeAws_restJson1DeleteChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteChannelCommand = serializeAws_restJson1DeleteChannelCommand;
const serializeAws_restJson1DeleteOriginEndpointCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/origin_endpoints/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteOriginEndpointCommand = serializeAws_restJson1DeleteOriginEndpointCommand;
const serializeAws_restJson1DescribeChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeChannelCommand = serializeAws_restJson1DescribeChannelCommand;
const serializeAws_restJson1DescribeHarvestJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/harvest_jobs/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeHarvestJobCommand = serializeAws_restJson1DescribeHarvestJobCommand;
const serializeAws_restJson1DescribeOriginEndpointCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/origin_endpoints/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeOriginEndpointCommand = serializeAws_restJson1DescribeOriginEndpointCommand;
const serializeAws_restJson1ListChannelsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels";
    const query = {
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListChannelsCommand = serializeAws_restJson1ListChannelsCommand;
const serializeAws_restJson1ListHarvestJobsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/harvest_jobs";
    const query = {
        ...(input.IncludeChannelId !== undefined && { includeChannelId: input.IncludeChannelId }),
        ...(input.IncludeStatus !== undefined && { includeStatus: input.IncludeStatus }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListHarvestJobsCommand = serializeAws_restJson1ListHarvestJobsCommand;
const serializeAws_restJson1ListOriginEndpointsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/origin_endpoints";
    const query = {
        ...(input.ChannelId !== undefined && { channelId: input.ChannelId }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListOriginEndpointsCommand = serializeAws_restJson1ListOriginEndpointsCommand;
const serializeAws_restJson1ListTagsForResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListTagsForResourceCommand = serializeAws_restJson1ListTagsForResourceCommand;
const serializeAws_restJson1RotateChannelCredentialsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}/credentials";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1RotateChannelCredentialsCommand = serializeAws_restJson1RotateChannelCredentialsCommand;
const serializeAws_restJson1RotateIngestEndpointCredentialsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/channels/{Id}/ingest_endpoints/{IngestEndpointId}/credentials";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    if (input.IngestEndpointId !== undefined) {
        const labelValue = input.IngestEndpointId;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: IngestEndpointId.");
        }
        resolvedPath = resolvedPath.replace("{IngestEndpointId}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: IngestEndpointId.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1RotateIngestEndpointCredentialsCommand = serializeAws_restJson1RotateIngestEndpointCredentialsCommand;
const serializeAws_restJson1TagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Tags !== undefined &&
            input.Tags !== null && { tags: serializeAws_restJson1__mapOf__string(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1TagResourceCommand = serializeAws_restJson1TagResourceCommand;
const serializeAws_restJson1UntagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    const query = {
        ...(input.TagKeys !== undefined && { tagKeys: (input.TagKeys || []).map((_entry) => _entry) }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1UntagResourceCommand = serializeAws_restJson1UntagResourceCommand;
const serializeAws_restJson1UpdateChannelCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/channels/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateChannelCommand = serializeAws_restJson1UpdateChannelCommand;
const serializeAws_restJson1UpdateOriginEndpointCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/origin_endpoints/{Id}";
    if (input.Id !== undefined) {
        const labelValue = input.Id;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Id.");
        }
        resolvedPath = resolvedPath.replace("{Id}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Id.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Authorization !== undefined &&
            input.Authorization !== null && {
            authorization: serializeAws_restJson1Authorization(input.Authorization, context),
        }),
        ...(input.CmafPackage !== undefined &&
            input.CmafPackage !== null && {
            cmafPackage: serializeAws_restJson1CmafPackageCreateOrUpdateParameters(input.CmafPackage, context),
        }),
        ...(input.DashPackage !== undefined &&
            input.DashPackage !== null && { dashPackage: serializeAws_restJson1DashPackage(input.DashPackage, context) }),
        ...(input.Description !== undefined && input.Description !== null && { description: input.Description }),
        ...(input.HlsPackage !== undefined &&
            input.HlsPackage !== null && { hlsPackage: serializeAws_restJson1HlsPackage(input.HlsPackage, context) }),
        ...(input.ManifestName !== undefined && input.ManifestName !== null && { manifestName: input.ManifestName }),
        ...(input.MssPackage !== undefined &&
            input.MssPackage !== null && { mssPackage: serializeAws_restJson1MssPackage(input.MssPackage, context) }),
        ...(input.Origination !== undefined && input.Origination !== null && { origination: input.Origination }),
        ...(input.StartoverWindowSeconds !== undefined &&
            input.StartoverWindowSeconds !== null && { startoverWindowSeconds: input.StartoverWindowSeconds }),
        ...(input.TimeDelaySeconds !== undefined &&
            input.TimeDelaySeconds !== null && { timeDelaySeconds: input.TimeDelaySeconds }),
        ...(input.Whitelist !== undefined &&
            input.Whitelist !== null && { whitelist: serializeAws_restJson1__listOf__string(input.Whitelist, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1UpdateOriginEndpointCommand = serializeAws_restJson1UpdateOriginEndpointCommand;
const deserializeAws_restJson1ConfigureLogsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ConfigureLogsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ConfigureLogsCommand = deserializeAws_restJson1ConfigureLogsCommand;
const deserializeAws_restJson1ConfigureLogsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateChannelCommand = deserializeAws_restJson1CreateChannelCommand;
const deserializeAws_restJson1CreateChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateHarvestJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateHarvestJobCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        ChannelId: undefined,
        CreatedAt: undefined,
        EndTime: undefined,
        Id: undefined,
        OriginEndpointId: undefined,
        S3Destination: undefined,
        StartTime: undefined,
        Status: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.channelId !== undefined && data.channelId !== null) {
        contents.ChannelId = (0, smithy_client_1.expectString)(data.channelId);
    }
    if (data.createdAt !== undefined && data.createdAt !== null) {
        contents.CreatedAt = (0, smithy_client_1.expectString)(data.createdAt);
    }
    if (data.endTime !== undefined && data.endTime !== null) {
        contents.EndTime = (0, smithy_client_1.expectString)(data.endTime);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.originEndpointId !== undefined && data.originEndpointId !== null) {
        contents.OriginEndpointId = (0, smithy_client_1.expectString)(data.originEndpointId);
    }
    if (data.s3Destination !== undefined && data.s3Destination !== null) {
        contents.S3Destination = deserializeAws_restJson1S3Destination(data.s3Destination, context);
    }
    if (data.startTime !== undefined && data.startTime !== null) {
        contents.StartTime = (0, smithy_client_1.expectString)(data.startTime);
    }
    if (data.status !== undefined && data.status !== null) {
        contents.Status = (0, smithy_client_1.expectString)(data.status);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateHarvestJobCommand = deserializeAws_restJson1CreateHarvestJobCommand;
const deserializeAws_restJson1CreateHarvestJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateOriginEndpointCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Authorization: undefined,
        ChannelId: undefined,
        CmafPackage: undefined,
        DashPackage: undefined,
        Description: undefined,
        HlsPackage: undefined,
        Id: undefined,
        ManifestName: undefined,
        MssPackage: undefined,
        Origination: undefined,
        StartoverWindowSeconds: undefined,
        Tags: undefined,
        TimeDelaySeconds: undefined,
        Url: undefined,
        Whitelist: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.authorization !== undefined && data.authorization !== null) {
        contents.Authorization = deserializeAws_restJson1Authorization(data.authorization, context);
    }
    if (data.channelId !== undefined && data.channelId !== null) {
        contents.ChannelId = (0, smithy_client_1.expectString)(data.channelId);
    }
    if (data.cmafPackage !== undefined && data.cmafPackage !== null) {
        contents.CmafPackage = deserializeAws_restJson1CmafPackage(data.cmafPackage, context);
    }
    if (data.dashPackage !== undefined && data.dashPackage !== null) {
        contents.DashPackage = deserializeAws_restJson1DashPackage(data.dashPackage, context);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.hlsPackage !== undefined && data.hlsPackage !== null) {
        contents.HlsPackage = deserializeAws_restJson1HlsPackage(data.hlsPackage, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.manifestName !== undefined && data.manifestName !== null) {
        contents.ManifestName = (0, smithy_client_1.expectString)(data.manifestName);
    }
    if (data.mssPackage !== undefined && data.mssPackage !== null) {
        contents.MssPackage = deserializeAws_restJson1MssPackage(data.mssPackage, context);
    }
    if (data.origination !== undefined && data.origination !== null) {
        contents.Origination = (0, smithy_client_1.expectString)(data.origination);
    }
    if (data.startoverWindowSeconds !== undefined && data.startoverWindowSeconds !== null) {
        contents.StartoverWindowSeconds = (0, smithy_client_1.expectInt32)(data.startoverWindowSeconds);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    if (data.timeDelaySeconds !== undefined && data.timeDelaySeconds !== null) {
        contents.TimeDelaySeconds = (0, smithy_client_1.expectInt32)(data.timeDelaySeconds);
    }
    if (data.url !== undefined && data.url !== null) {
        contents.Url = (0, smithy_client_1.expectString)(data.url);
    }
    if (data.whitelist !== undefined && data.whitelist !== null) {
        contents.Whitelist = deserializeAws_restJson1__listOf__string(data.whitelist, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateOriginEndpointCommand = deserializeAws_restJson1CreateOriginEndpointCommand;
const deserializeAws_restJson1CreateOriginEndpointCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteChannelCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteChannelCommand = deserializeAws_restJson1DeleteChannelCommand;
const deserializeAws_restJson1DeleteChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteOriginEndpointCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteOriginEndpointCommand = deserializeAws_restJson1DeleteOriginEndpointCommand;
const deserializeAws_restJson1DeleteOriginEndpointCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeChannelCommand = deserializeAws_restJson1DescribeChannelCommand;
const deserializeAws_restJson1DescribeChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeHarvestJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeHarvestJobCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        ChannelId: undefined,
        CreatedAt: undefined,
        EndTime: undefined,
        Id: undefined,
        OriginEndpointId: undefined,
        S3Destination: undefined,
        StartTime: undefined,
        Status: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.channelId !== undefined && data.channelId !== null) {
        contents.ChannelId = (0, smithy_client_1.expectString)(data.channelId);
    }
    if (data.createdAt !== undefined && data.createdAt !== null) {
        contents.CreatedAt = (0, smithy_client_1.expectString)(data.createdAt);
    }
    if (data.endTime !== undefined && data.endTime !== null) {
        contents.EndTime = (0, smithy_client_1.expectString)(data.endTime);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.originEndpointId !== undefined && data.originEndpointId !== null) {
        contents.OriginEndpointId = (0, smithy_client_1.expectString)(data.originEndpointId);
    }
    if (data.s3Destination !== undefined && data.s3Destination !== null) {
        contents.S3Destination = deserializeAws_restJson1S3Destination(data.s3Destination, context);
    }
    if (data.startTime !== undefined && data.startTime !== null) {
        contents.StartTime = (0, smithy_client_1.expectString)(data.startTime);
    }
    if (data.status !== undefined && data.status !== null) {
        contents.Status = (0, smithy_client_1.expectString)(data.status);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeHarvestJobCommand = deserializeAws_restJson1DescribeHarvestJobCommand;
const deserializeAws_restJson1DescribeHarvestJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeOriginEndpointCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Authorization: undefined,
        ChannelId: undefined,
        CmafPackage: undefined,
        DashPackage: undefined,
        Description: undefined,
        HlsPackage: undefined,
        Id: undefined,
        ManifestName: undefined,
        MssPackage: undefined,
        Origination: undefined,
        StartoverWindowSeconds: undefined,
        Tags: undefined,
        TimeDelaySeconds: undefined,
        Url: undefined,
        Whitelist: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.authorization !== undefined && data.authorization !== null) {
        contents.Authorization = deserializeAws_restJson1Authorization(data.authorization, context);
    }
    if (data.channelId !== undefined && data.channelId !== null) {
        contents.ChannelId = (0, smithy_client_1.expectString)(data.channelId);
    }
    if (data.cmafPackage !== undefined && data.cmafPackage !== null) {
        contents.CmafPackage = deserializeAws_restJson1CmafPackage(data.cmafPackage, context);
    }
    if (data.dashPackage !== undefined && data.dashPackage !== null) {
        contents.DashPackage = deserializeAws_restJson1DashPackage(data.dashPackage, context);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.hlsPackage !== undefined && data.hlsPackage !== null) {
        contents.HlsPackage = deserializeAws_restJson1HlsPackage(data.hlsPackage, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.manifestName !== undefined && data.manifestName !== null) {
        contents.ManifestName = (0, smithy_client_1.expectString)(data.manifestName);
    }
    if (data.mssPackage !== undefined && data.mssPackage !== null) {
        contents.MssPackage = deserializeAws_restJson1MssPackage(data.mssPackage, context);
    }
    if (data.origination !== undefined && data.origination !== null) {
        contents.Origination = (0, smithy_client_1.expectString)(data.origination);
    }
    if (data.startoverWindowSeconds !== undefined && data.startoverWindowSeconds !== null) {
        contents.StartoverWindowSeconds = (0, smithy_client_1.expectInt32)(data.startoverWindowSeconds);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    if (data.timeDelaySeconds !== undefined && data.timeDelaySeconds !== null) {
        contents.TimeDelaySeconds = (0, smithy_client_1.expectInt32)(data.timeDelaySeconds);
    }
    if (data.url !== undefined && data.url !== null) {
        contents.Url = (0, smithy_client_1.expectString)(data.url);
    }
    if (data.whitelist !== undefined && data.whitelist !== null) {
        contents.Whitelist = deserializeAws_restJson1__listOf__string(data.whitelist, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeOriginEndpointCommand = deserializeAws_restJson1DescribeOriginEndpointCommand;
const deserializeAws_restJson1DescribeOriginEndpointCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListChannelsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListChannelsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Channels: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.channels !== undefined && data.channels !== null) {
        contents.Channels = deserializeAws_restJson1__listOfChannel(data.channels, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListChannelsCommand = deserializeAws_restJson1ListChannelsCommand;
const deserializeAws_restJson1ListChannelsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListHarvestJobsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListHarvestJobsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        HarvestJobs: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.harvestJobs !== undefined && data.harvestJobs !== null) {
        contents.HarvestJobs = deserializeAws_restJson1__listOfHarvestJob(data.harvestJobs, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListHarvestJobsCommand = deserializeAws_restJson1ListHarvestJobsCommand;
const deserializeAws_restJson1ListHarvestJobsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListOriginEndpointsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListOriginEndpointsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        OriginEndpoints: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    if (data.originEndpoints !== undefined && data.originEndpoints !== null) {
        contents.OriginEndpoints = deserializeAws_restJson1__listOfOriginEndpoint(data.originEndpoints, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListOriginEndpointsCommand = deserializeAws_restJson1ListOriginEndpointsCommand;
const deserializeAws_restJson1ListOriginEndpointsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListTagsForResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1__mapOf__string(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListTagsForResourceCommand = deserializeAws_restJson1ListTagsForResourceCommand;
const deserializeAws_restJson1ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1RotateChannelCredentialsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1RotateChannelCredentialsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1RotateChannelCredentialsCommand = deserializeAws_restJson1RotateChannelCredentialsCommand;
const deserializeAws_restJson1RotateChannelCredentialsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1RotateIngestEndpointCredentialsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1RotateIngestEndpointCredentialsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1RotateIngestEndpointCredentialsCommand = deserializeAws_restJson1RotateIngestEndpointCredentialsCommand;
const deserializeAws_restJson1RotateIngestEndpointCredentialsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return deserializeAws_restJson1TagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1TagResourceCommand = deserializeAws_restJson1TagResourceCommand;
const deserializeAws_restJson1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return deserializeAws_restJson1UntagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UntagResourceCommand = deserializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateChannelCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Description: undefined,
        EgressAccessLogs: undefined,
        HlsIngest: undefined,
        Id: undefined,
        IngressAccessLogs: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.egressAccessLogs !== undefined && data.egressAccessLogs !== null) {
        contents.EgressAccessLogs = deserializeAws_restJson1EgressAccessLogs(data.egressAccessLogs, context);
    }
    if (data.hlsIngest !== undefined && data.hlsIngest !== null) {
        contents.HlsIngest = deserializeAws_restJson1HlsIngest(data.hlsIngest, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.ingressAccessLogs !== undefined && data.ingressAccessLogs !== null) {
        contents.IngressAccessLogs = deserializeAws_restJson1IngressAccessLogs(data.ingressAccessLogs, context);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateChannelCommand = deserializeAws_restJson1UpdateChannelCommand;
const deserializeAws_restJson1UpdateChannelCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UpdateOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UpdateOriginEndpointCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        Authorization: undefined,
        ChannelId: undefined,
        CmafPackage: undefined,
        DashPackage: undefined,
        Description: undefined,
        HlsPackage: undefined,
        Id: undefined,
        ManifestName: undefined,
        MssPackage: undefined,
        Origination: undefined,
        StartoverWindowSeconds: undefined,
        Tags: undefined,
        TimeDelaySeconds: undefined,
        Url: undefined,
        Whitelist: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.arn !== undefined && data.arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.arn);
    }
    if (data.authorization !== undefined && data.authorization !== null) {
        contents.Authorization = deserializeAws_restJson1Authorization(data.authorization, context);
    }
    if (data.channelId !== undefined && data.channelId !== null) {
        contents.ChannelId = (0, smithy_client_1.expectString)(data.channelId);
    }
    if (data.cmafPackage !== undefined && data.cmafPackage !== null) {
        contents.CmafPackage = deserializeAws_restJson1CmafPackage(data.cmafPackage, context);
    }
    if (data.dashPackage !== undefined && data.dashPackage !== null) {
        contents.DashPackage = deserializeAws_restJson1DashPackage(data.dashPackage, context);
    }
    if (data.description !== undefined && data.description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.description);
    }
    if (data.hlsPackage !== undefined && data.hlsPackage !== null) {
        contents.HlsPackage = deserializeAws_restJson1HlsPackage(data.hlsPackage, context);
    }
    if (data.id !== undefined && data.id !== null) {
        contents.Id = (0, smithy_client_1.expectString)(data.id);
    }
    if (data.manifestName !== undefined && data.manifestName !== null) {
        contents.ManifestName = (0, smithy_client_1.expectString)(data.manifestName);
    }
    if (data.mssPackage !== undefined && data.mssPackage !== null) {
        contents.MssPackage = deserializeAws_restJson1MssPackage(data.mssPackage, context);
    }
    if (data.origination !== undefined && data.origination !== null) {
        contents.Origination = (0, smithy_client_1.expectString)(data.origination);
    }
    if (data.startoverWindowSeconds !== undefined && data.startoverWindowSeconds !== null) {
        contents.StartoverWindowSeconds = (0, smithy_client_1.expectInt32)(data.startoverWindowSeconds);
    }
    if (data.tags !== undefined && data.tags !== null) {
        contents.Tags = deserializeAws_restJson1Tags(data.tags, context);
    }
    if (data.timeDelaySeconds !== undefined && data.timeDelaySeconds !== null) {
        contents.TimeDelaySeconds = (0, smithy_client_1.expectInt32)(data.timeDelaySeconds);
    }
    if (data.url !== undefined && data.url !== null) {
        contents.Url = (0, smithy_client_1.expectString)(data.url);
    }
    if (data.whitelist !== undefined && data.whitelist !== null) {
        contents.Whitelist = deserializeAws_restJson1__listOf__string(data.whitelist, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UpdateOriginEndpointCommand = deserializeAws_restJson1UpdateOriginEndpointCommand;
const deserializeAws_restJson1UpdateOriginEndpointCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.mediapackage#ForbiddenException":
            throw await deserializeAws_restJson1ForbiddenExceptionResponse(parsedOutput, context);
        case "InternalServerErrorException":
        case "com.amazonaws.mediapackage#InternalServerErrorException":
            throw await deserializeAws_restJson1InternalServerErrorExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.mediapackage#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.mediapackage#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "TooManyRequestsException":
        case "com.amazonaws.mediapackage#TooManyRequestsException":
            throw await deserializeAws_restJson1TooManyRequestsExceptionResponse(parsedOutput, context);
        case "UnprocessableEntityException":
        case "com.amazonaws.mediapackage#UnprocessableEntityException":
            throw await deserializeAws_restJson1UnprocessableEntityExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MediaPackageServiceException_1.MediaPackageServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ForbiddenExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ForbiddenException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalServerErrorExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.InternalServerErrorException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1NotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.NotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceUnavailableExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ServiceUnavailableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1TooManyRequestsExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.TooManyRequestsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1UnprocessableEntityExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.UnprocessableEntityException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1__listOf__PeriodTriggersElement = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1__listOf__string = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1__listOfHlsManifestCreateOrUpdateParameters = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1HlsManifestCreateOrUpdateParameters(entry, context);
    });
};
const serializeAws_restJson1__mapOf__string = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const serializeAws_restJson1AdTriggers = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1Authorization = (input, context) => {
    return {
        ...(input.CdnIdentifierSecret !== undefined &&
            input.CdnIdentifierSecret !== null && { cdnIdentifierSecret: input.CdnIdentifierSecret }),
        ...(input.SecretsRoleArn !== undefined &&
            input.SecretsRoleArn !== null && { secretsRoleArn: input.SecretsRoleArn }),
    };
};
const serializeAws_restJson1CmafEncryption = (input, context) => {
    return {
        ...(input.ConstantInitializationVector !== undefined &&
            input.ConstantInitializationVector !== null && {
            constantInitializationVector: input.ConstantInitializationVector,
        }),
        ...(input.KeyRotationIntervalSeconds !== undefined &&
            input.KeyRotationIntervalSeconds !== null && { keyRotationIntervalSeconds: input.KeyRotationIntervalSeconds }),
        ...(input.SpekeKeyProvider !== undefined &&
            input.SpekeKeyProvider !== null && {
            spekeKeyProvider: serializeAws_restJson1SpekeKeyProvider(input.SpekeKeyProvider, context),
        }),
    };
};
const serializeAws_restJson1CmafPackageCreateOrUpdateParameters = (input, context) => {
    return {
        ...(input.Encryption !== undefined &&
            input.Encryption !== null && { encryption: serializeAws_restJson1CmafEncryption(input.Encryption, context) }),
        ...(input.HlsManifests !== undefined &&
            input.HlsManifests !== null && {
            hlsManifests: serializeAws_restJson1__listOfHlsManifestCreateOrUpdateParameters(input.HlsManifests, context),
        }),
        ...(input.SegmentDurationSeconds !== undefined &&
            input.SegmentDurationSeconds !== null && { segmentDurationSeconds: input.SegmentDurationSeconds }),
        ...(input.SegmentPrefix !== undefined && input.SegmentPrefix !== null && { segmentPrefix: input.SegmentPrefix }),
        ...(input.StreamSelection !== undefined &&
            input.StreamSelection !== null && {
            streamSelection: serializeAws_restJson1StreamSelection(input.StreamSelection, context),
        }),
    };
};
const serializeAws_restJson1DashEncryption = (input, context) => {
    return {
        ...(input.KeyRotationIntervalSeconds !== undefined &&
            input.KeyRotationIntervalSeconds !== null && { keyRotationIntervalSeconds: input.KeyRotationIntervalSeconds }),
        ...(input.SpekeKeyProvider !== undefined &&
            input.SpekeKeyProvider !== null && {
            spekeKeyProvider: serializeAws_restJson1SpekeKeyProvider(input.SpekeKeyProvider, context),
        }),
    };
};
const serializeAws_restJson1DashPackage = (input, context) => {
    return {
        ...(input.AdTriggers !== undefined &&
            input.AdTriggers !== null && { adTriggers: serializeAws_restJson1AdTriggers(input.AdTriggers, context) }),
        ...(input.AdsOnDeliveryRestrictions !== undefined &&
            input.AdsOnDeliveryRestrictions !== null && { adsOnDeliveryRestrictions: input.AdsOnDeliveryRestrictions }),
        ...(input.Encryption !== undefined &&
            input.Encryption !== null && { encryption: serializeAws_restJson1DashEncryption(input.Encryption, context) }),
        ...(input.ManifestLayout !== undefined &&
            input.ManifestLayout !== null && { manifestLayout: input.ManifestLayout }),
        ...(input.ManifestWindowSeconds !== undefined &&
            input.ManifestWindowSeconds !== null && { manifestWindowSeconds: input.ManifestWindowSeconds }),
        ...(input.MinBufferTimeSeconds !== undefined &&
            input.MinBufferTimeSeconds !== null && { minBufferTimeSeconds: input.MinBufferTimeSeconds }),
        ...(input.MinUpdatePeriodSeconds !== undefined &&
            input.MinUpdatePeriodSeconds !== null && { minUpdatePeriodSeconds: input.MinUpdatePeriodSeconds }),
        ...(input.PeriodTriggers !== undefined &&
            input.PeriodTriggers !== null && {
            periodTriggers: serializeAws_restJson1__listOf__PeriodTriggersElement(input.PeriodTriggers, context),
        }),
        ...(input.Profile !== undefined && input.Profile !== null && { profile: input.Profile }),
        ...(input.SegmentDurationSeconds !== undefined &&
            input.SegmentDurationSeconds !== null && { segmentDurationSeconds: input.SegmentDurationSeconds }),
        ...(input.SegmentTemplateFormat !== undefined &&
            input.SegmentTemplateFormat !== null && { segmentTemplateFormat: input.SegmentTemplateFormat }),
        ...(input.StreamSelection !== undefined &&
            input.StreamSelection !== null && {
            streamSelection: serializeAws_restJson1StreamSelection(input.StreamSelection, context),
        }),
        ...(input.SuggestedPresentationDelaySeconds !== undefined &&
            input.SuggestedPresentationDelaySeconds !== null && {
            suggestedPresentationDelaySeconds: input.SuggestedPresentationDelaySeconds,
        }),
        ...(input.UtcTiming !== undefined && input.UtcTiming !== null && { utcTiming: input.UtcTiming }),
        ...(input.UtcTimingUri !== undefined && input.UtcTimingUri !== null && { utcTimingUri: input.UtcTimingUri }),
    };
};
const serializeAws_restJson1EgressAccessLogs = (input, context) => {
    return {
        ...(input.LogGroupName !== undefined && input.LogGroupName !== null && { logGroupName: input.LogGroupName }),
    };
};
const serializeAws_restJson1EncryptionContractConfiguration = (input, context) => {
    return {
        ...(input.PresetSpeke20Audio !== undefined &&
            input.PresetSpeke20Audio !== null && { presetSpeke20Audio: input.PresetSpeke20Audio }),
        ...(input.PresetSpeke20Video !== undefined &&
            input.PresetSpeke20Video !== null && { presetSpeke20Video: input.PresetSpeke20Video }),
    };
};
const serializeAws_restJson1HlsEncryption = (input, context) => {
    return {
        ...(input.ConstantInitializationVector !== undefined &&
            input.ConstantInitializationVector !== null && {
            constantInitializationVector: input.ConstantInitializationVector,
        }),
        ...(input.EncryptionMethod !== undefined &&
            input.EncryptionMethod !== null && { encryptionMethod: input.EncryptionMethod }),
        ...(input.KeyRotationIntervalSeconds !== undefined &&
            input.KeyRotationIntervalSeconds !== null && { keyRotationIntervalSeconds: input.KeyRotationIntervalSeconds }),
        ...(input.RepeatExtXKey !== undefined && input.RepeatExtXKey !== null && { repeatExtXKey: input.RepeatExtXKey }),
        ...(input.SpekeKeyProvider !== undefined &&
            input.SpekeKeyProvider !== null && {
            spekeKeyProvider: serializeAws_restJson1SpekeKeyProvider(input.SpekeKeyProvider, context),
        }),
    };
};
const serializeAws_restJson1HlsManifestCreateOrUpdateParameters = (input, context) => {
    return {
        ...(input.AdMarkers !== undefined && input.AdMarkers !== null && { adMarkers: input.AdMarkers }),
        ...(input.AdTriggers !== undefined &&
            input.AdTriggers !== null && { adTriggers: serializeAws_restJson1AdTriggers(input.AdTriggers, context) }),
        ...(input.AdsOnDeliveryRestrictions !== undefined &&
            input.AdsOnDeliveryRestrictions !== null && { adsOnDeliveryRestrictions: input.AdsOnDeliveryRestrictions }),
        ...(input.Id !== undefined && input.Id !== null && { id: input.Id }),
        ...(input.IncludeIframeOnlyStream !== undefined &&
            input.IncludeIframeOnlyStream !== null && { includeIframeOnlyStream: input.IncludeIframeOnlyStream }),
        ...(input.ManifestName !== undefined && input.ManifestName !== null && { manifestName: input.ManifestName }),
        ...(input.PlaylistType !== undefined && input.PlaylistType !== null && { playlistType: input.PlaylistType }),
        ...(input.PlaylistWindowSeconds !== undefined &&
            input.PlaylistWindowSeconds !== null && { playlistWindowSeconds: input.PlaylistWindowSeconds }),
        ...(input.ProgramDateTimeIntervalSeconds !== undefined &&
            input.ProgramDateTimeIntervalSeconds !== null && {
            programDateTimeIntervalSeconds: input.ProgramDateTimeIntervalSeconds,
        }),
    };
};
const serializeAws_restJson1HlsPackage = (input, context) => {
    return {
        ...(input.AdMarkers !== undefined && input.AdMarkers !== null && { adMarkers: input.AdMarkers }),
        ...(input.AdTriggers !== undefined &&
            input.AdTriggers !== null && { adTriggers: serializeAws_restJson1AdTriggers(input.AdTriggers, context) }),
        ...(input.AdsOnDeliveryRestrictions !== undefined &&
            input.AdsOnDeliveryRestrictions !== null && { adsOnDeliveryRestrictions: input.AdsOnDeliveryRestrictions }),
        ...(input.Encryption !== undefined &&
            input.Encryption !== null && { encryption: serializeAws_restJson1HlsEncryption(input.Encryption, context) }),
        ...(input.IncludeDvbSubtitles !== undefined &&
            input.IncludeDvbSubtitles !== null && { includeDvbSubtitles: input.IncludeDvbSubtitles }),
        ...(input.IncludeIframeOnlyStream !== undefined &&
            input.IncludeIframeOnlyStream !== null && { includeIframeOnlyStream: input.IncludeIframeOnlyStream }),
        ...(input.PlaylistType !== undefined && input.PlaylistType !== null && { playlistType: input.PlaylistType }),
        ...(input.PlaylistWindowSeconds !== undefined &&
            input.PlaylistWindowSeconds !== null && { playlistWindowSeconds: input.PlaylistWindowSeconds }),
        ...(input.ProgramDateTimeIntervalSeconds !== undefined &&
            input.ProgramDateTimeIntervalSeconds !== null && {
            programDateTimeIntervalSeconds: input.ProgramDateTimeIntervalSeconds,
        }),
        ...(input.SegmentDurationSeconds !== undefined &&
            input.SegmentDurationSeconds !== null && { segmentDurationSeconds: input.SegmentDurationSeconds }),
        ...(input.StreamSelection !== undefined &&
            input.StreamSelection !== null && {
            streamSelection: serializeAws_restJson1StreamSelection(input.StreamSelection, context),
        }),
        ...(input.UseAudioRenditionGroup !== undefined &&
            input.UseAudioRenditionGroup !== null && { useAudioRenditionGroup: input.UseAudioRenditionGroup }),
    };
};
const serializeAws_restJson1IngressAccessLogs = (input, context) => {
    return {
        ...(input.LogGroupName !== undefined && input.LogGroupName !== null && { logGroupName: input.LogGroupName }),
    };
};
const serializeAws_restJson1MssEncryption = (input, context) => {
    return {
        ...(input.SpekeKeyProvider !== undefined &&
            input.SpekeKeyProvider !== null && {
            spekeKeyProvider: serializeAws_restJson1SpekeKeyProvider(input.SpekeKeyProvider, context),
        }),
    };
};
const serializeAws_restJson1MssPackage = (input, context) => {
    return {
        ...(input.Encryption !== undefined &&
            input.Encryption !== null && { encryption: serializeAws_restJson1MssEncryption(input.Encryption, context) }),
        ...(input.ManifestWindowSeconds !== undefined &&
            input.ManifestWindowSeconds !== null && { manifestWindowSeconds: input.ManifestWindowSeconds }),
        ...(input.SegmentDurationSeconds !== undefined &&
            input.SegmentDurationSeconds !== null && { segmentDurationSeconds: input.SegmentDurationSeconds }),
        ...(input.StreamSelection !== undefined &&
            input.StreamSelection !== null && {
            streamSelection: serializeAws_restJson1StreamSelection(input.StreamSelection, context),
        }),
    };
};
const serializeAws_restJson1S3Destination = (input, context) => {
    return {
        ...(input.BucketName !== undefined && input.BucketName !== null && { bucketName: input.BucketName }),
        ...(input.ManifestKey !== undefined && input.ManifestKey !== null && { manifestKey: input.ManifestKey }),
        ...(input.RoleArn !== undefined && input.RoleArn !== null && { roleArn: input.RoleArn }),
    };
};
const serializeAws_restJson1SpekeKeyProvider = (input, context) => {
    return {
        ...(input.CertificateArn !== undefined &&
            input.CertificateArn !== null && { certificateArn: input.CertificateArn }),
        ...(input.EncryptionContractConfiguration !== undefined &&
            input.EncryptionContractConfiguration !== null && {
            encryptionContractConfiguration: serializeAws_restJson1EncryptionContractConfiguration(input.EncryptionContractConfiguration, context),
        }),
        ...(input.ResourceId !== undefined && input.ResourceId !== null && { resourceId: input.ResourceId }),
        ...(input.RoleArn !== undefined && input.RoleArn !== null && { roleArn: input.RoleArn }),
        ...(input.SystemIds !== undefined &&
            input.SystemIds !== null && { systemIds: serializeAws_restJson1__listOf__string(input.SystemIds, context) }),
        ...(input.Url !== undefined && input.Url !== null && { url: input.Url }),
    };
};
const serializeAws_restJson1StreamSelection = (input, context) => {
    return {
        ...(input.MaxVideoBitsPerSecond !== undefined &&
            input.MaxVideoBitsPerSecond !== null && { maxVideoBitsPerSecond: input.MaxVideoBitsPerSecond }),
        ...(input.MinVideoBitsPerSecond !== undefined &&
            input.MinVideoBitsPerSecond !== null && { minVideoBitsPerSecond: input.MinVideoBitsPerSecond }),
        ...(input.StreamOrder !== undefined && input.StreamOrder !== null && { streamOrder: input.StreamOrder }),
    };
};
const serializeAws_restJson1Tags = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const deserializeAws_restJson1__listOf__PeriodTriggersElement = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1__listOf__string = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfChannel = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Channel(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfHarvestJob = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1HarvestJob(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfHlsManifest = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1HlsManifest(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfIngestEndpoint = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1IngestEndpoint(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__listOfOriginEndpoint = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1OriginEndpoint(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1__mapOf__string = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1AdTriggers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1Authorization = (output, context) => {
    return {
        CdnIdentifierSecret: (0, smithy_client_1.expectString)(output.cdnIdentifierSecret),
        SecretsRoleArn: (0, smithy_client_1.expectString)(output.secretsRoleArn),
    };
};
const deserializeAws_restJson1Channel = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.arn),
        Description: (0, smithy_client_1.expectString)(output.description),
        EgressAccessLogs: output.egressAccessLogs !== undefined && output.egressAccessLogs !== null
            ? deserializeAws_restJson1EgressAccessLogs(output.egressAccessLogs, context)
            : undefined,
        HlsIngest: output.hlsIngest !== undefined && output.hlsIngest !== null
            ? deserializeAws_restJson1HlsIngest(output.hlsIngest, context)
            : undefined,
        Id: (0, smithy_client_1.expectString)(output.id),
        IngressAccessLogs: output.ingressAccessLogs !== undefined && output.ingressAccessLogs !== null
            ? deserializeAws_restJson1IngressAccessLogs(output.ingressAccessLogs, context)
            : undefined,
        Tags: output.tags !== undefined && output.tags !== null
            ? deserializeAws_restJson1Tags(output.tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1CmafEncryption = (output, context) => {
    return {
        ConstantInitializationVector: (0, smithy_client_1.expectString)(output.constantInitializationVector),
        KeyRotationIntervalSeconds: (0, smithy_client_1.expectInt32)(output.keyRotationIntervalSeconds),
        SpekeKeyProvider: output.spekeKeyProvider !== undefined && output.spekeKeyProvider !== null
            ? deserializeAws_restJson1SpekeKeyProvider(output.spekeKeyProvider, context)
            : undefined,
    };
};
const deserializeAws_restJson1CmafPackage = (output, context) => {
    return {
        Encryption: output.encryption !== undefined && output.encryption !== null
            ? deserializeAws_restJson1CmafEncryption(output.encryption, context)
            : undefined,
        HlsManifests: output.hlsManifests !== undefined && output.hlsManifests !== null
            ? deserializeAws_restJson1__listOfHlsManifest(output.hlsManifests, context)
            : undefined,
        SegmentDurationSeconds: (0, smithy_client_1.expectInt32)(output.segmentDurationSeconds),
        SegmentPrefix: (0, smithy_client_1.expectString)(output.segmentPrefix),
        StreamSelection: output.streamSelection !== undefined && output.streamSelection !== null
            ? deserializeAws_restJson1StreamSelection(output.streamSelection, context)
            : undefined,
    };
};
const deserializeAws_restJson1DashEncryption = (output, context) => {
    return {
        KeyRotationIntervalSeconds: (0, smithy_client_1.expectInt32)(output.keyRotationIntervalSeconds),
        SpekeKeyProvider: output.spekeKeyProvider !== undefined && output.spekeKeyProvider !== null
            ? deserializeAws_restJson1SpekeKeyProvider(output.spekeKeyProvider, context)
            : undefined,
    };
};
const deserializeAws_restJson1DashPackage = (output, context) => {
    return {
        AdTriggers: output.adTriggers !== undefined && output.adTriggers !== null
            ? deserializeAws_restJson1AdTriggers(output.adTriggers, context)
            : undefined,
        AdsOnDeliveryRestrictions: (0, smithy_client_1.expectString)(output.adsOnDeliveryRestrictions),
        Encryption: output.encryption !== undefined && output.encryption !== null
            ? deserializeAws_restJson1DashEncryption(output.encryption, context)
            : undefined,
        ManifestLayout: (0, smithy_client_1.expectString)(output.manifestLayout),
        ManifestWindowSeconds: (0, smithy_client_1.expectInt32)(output.manifestWindowSeconds),
        MinBufferTimeSeconds: (0, smithy_client_1.expectInt32)(output.minBufferTimeSeconds),
        MinUpdatePeriodSeconds: (0, smithy_client_1.expectInt32)(output.minUpdatePeriodSeconds),
        PeriodTriggers: output.periodTriggers !== undefined && output.periodTriggers !== null
            ? deserializeAws_restJson1__listOf__PeriodTriggersElement(output.periodTriggers, context)
            : undefined,
        Profile: (0, smithy_client_1.expectString)(output.profile),
        SegmentDurationSeconds: (0, smithy_client_1.expectInt32)(output.segmentDurationSeconds),
        SegmentTemplateFormat: (0, smithy_client_1.expectString)(output.segmentTemplateFormat),
        StreamSelection: output.streamSelection !== undefined && output.streamSelection !== null
            ? deserializeAws_restJson1StreamSelection(output.streamSelection, context)
            : undefined,
        SuggestedPresentationDelaySeconds: (0, smithy_client_1.expectInt32)(output.suggestedPresentationDelaySeconds),
        UtcTiming: (0, smithy_client_1.expectString)(output.utcTiming),
        UtcTimingUri: (0, smithy_client_1.expectString)(output.utcTimingUri),
    };
};
const deserializeAws_restJson1EgressAccessLogs = (output, context) => {
    return {
        LogGroupName: (0, smithy_client_1.expectString)(output.logGroupName),
    };
};
const deserializeAws_restJson1EncryptionContractConfiguration = (output, context) => {
    return {
        PresetSpeke20Audio: (0, smithy_client_1.expectString)(output.presetSpeke20Audio),
        PresetSpeke20Video: (0, smithy_client_1.expectString)(output.presetSpeke20Video),
    };
};
const deserializeAws_restJson1HarvestJob = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.arn),
        ChannelId: (0, smithy_client_1.expectString)(output.channelId),
        CreatedAt: (0, smithy_client_1.expectString)(output.createdAt),
        EndTime: (0, smithy_client_1.expectString)(output.endTime),
        Id: (0, smithy_client_1.expectString)(output.id),
        OriginEndpointId: (0, smithy_client_1.expectString)(output.originEndpointId),
        S3Destination: output.s3Destination !== undefined && output.s3Destination !== null
            ? deserializeAws_restJson1S3Destination(output.s3Destination, context)
            : undefined,
        StartTime: (0, smithy_client_1.expectString)(output.startTime),
        Status: (0, smithy_client_1.expectString)(output.status),
    };
};
const deserializeAws_restJson1HlsEncryption = (output, context) => {
    return {
        ConstantInitializationVector: (0, smithy_client_1.expectString)(output.constantInitializationVector),
        EncryptionMethod: (0, smithy_client_1.expectString)(output.encryptionMethod),
        KeyRotationIntervalSeconds: (0, smithy_client_1.expectInt32)(output.keyRotationIntervalSeconds),
        RepeatExtXKey: (0, smithy_client_1.expectBoolean)(output.repeatExtXKey),
        SpekeKeyProvider: output.spekeKeyProvider !== undefined && output.spekeKeyProvider !== null
            ? deserializeAws_restJson1SpekeKeyProvider(output.spekeKeyProvider, context)
            : undefined,
    };
};
const deserializeAws_restJson1HlsIngest = (output, context) => {
    return {
        IngestEndpoints: output.ingestEndpoints !== undefined && output.ingestEndpoints !== null
            ? deserializeAws_restJson1__listOfIngestEndpoint(output.ingestEndpoints, context)
            : undefined,
    };
};
const deserializeAws_restJson1HlsManifest = (output, context) => {
    return {
        AdMarkers: (0, smithy_client_1.expectString)(output.adMarkers),
        Id: (0, smithy_client_1.expectString)(output.id),
        IncludeIframeOnlyStream: (0, smithy_client_1.expectBoolean)(output.includeIframeOnlyStream),
        ManifestName: (0, smithy_client_1.expectString)(output.manifestName),
        PlaylistType: (0, smithy_client_1.expectString)(output.playlistType),
        PlaylistWindowSeconds: (0, smithy_client_1.expectInt32)(output.playlistWindowSeconds),
        ProgramDateTimeIntervalSeconds: (0, smithy_client_1.expectInt32)(output.programDateTimeIntervalSeconds),
        Url: (0, smithy_client_1.expectString)(output.url),
    };
};
const deserializeAws_restJson1HlsPackage = (output, context) => {
    return {
        AdMarkers: (0, smithy_client_1.expectString)(output.adMarkers),
        AdTriggers: output.adTriggers !== undefined && output.adTriggers !== null
            ? deserializeAws_restJson1AdTriggers(output.adTriggers, context)
            : undefined,
        AdsOnDeliveryRestrictions: (0, smithy_client_1.expectString)(output.adsOnDeliveryRestrictions),
        Encryption: output.encryption !== undefined && output.encryption !== null
            ? deserializeAws_restJson1HlsEncryption(output.encryption, context)
            : undefined,
        IncludeDvbSubtitles: (0, smithy_client_1.expectBoolean)(output.includeDvbSubtitles),
        IncludeIframeOnlyStream: (0, smithy_client_1.expectBoolean)(output.includeIframeOnlyStream),
        PlaylistType: (0, smithy_client_1.expectString)(output.playlistType),
        PlaylistWindowSeconds: (0, smithy_client_1.expectInt32)(output.playlistWindowSeconds),
        ProgramDateTimeIntervalSeconds: (0, smithy_client_1.expectInt32)(output.programDateTimeIntervalSeconds),
        SegmentDurationSeconds: (0, smithy_client_1.expectInt32)(output.segmentDurationSeconds),
        StreamSelection: output.streamSelection !== undefined && output.streamSelection !== null
            ? deserializeAws_restJson1StreamSelection(output.streamSelection, context)
            : undefined,
        UseAudioRenditionGroup: (0, smithy_client_1.expectBoolean)(output.useAudioRenditionGroup),
    };
};
const deserializeAws_restJson1IngestEndpoint = (output, context) => {
    return {
        Id: (0, smithy_client_1.expectString)(output.id),
        Password: (0, smithy_client_1.expectString)(output.password),
        Url: (0, smithy_client_1.expectString)(output.url),
        Username: (0, smithy_client_1.expectString)(output.username),
    };
};
const deserializeAws_restJson1IngressAccessLogs = (output, context) => {
    return {
        LogGroupName: (0, smithy_client_1.expectString)(output.logGroupName),
    };
};
const deserializeAws_restJson1MssEncryption = (output, context) => {
    return {
        SpekeKeyProvider: output.spekeKeyProvider !== undefined && output.spekeKeyProvider !== null
            ? deserializeAws_restJson1SpekeKeyProvider(output.spekeKeyProvider, context)
            : undefined,
    };
};
const deserializeAws_restJson1MssPackage = (output, context) => {
    return {
        Encryption: output.encryption !== undefined && output.encryption !== null
            ? deserializeAws_restJson1MssEncryption(output.encryption, context)
            : undefined,
        ManifestWindowSeconds: (0, smithy_client_1.expectInt32)(output.manifestWindowSeconds),
        SegmentDurationSeconds: (0, smithy_client_1.expectInt32)(output.segmentDurationSeconds),
        StreamSelection: output.streamSelection !== undefined && output.streamSelection !== null
            ? deserializeAws_restJson1StreamSelection(output.streamSelection, context)
            : undefined,
    };
};
const deserializeAws_restJson1OriginEndpoint = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.arn),
        Authorization: output.authorization !== undefined && output.authorization !== null
            ? deserializeAws_restJson1Authorization(output.authorization, context)
            : undefined,
        ChannelId: (0, smithy_client_1.expectString)(output.channelId),
        CmafPackage: output.cmafPackage !== undefined && output.cmafPackage !== null
            ? deserializeAws_restJson1CmafPackage(output.cmafPackage, context)
            : undefined,
        DashPackage: output.dashPackage !== undefined && output.dashPackage !== null
            ? deserializeAws_restJson1DashPackage(output.dashPackage, context)
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.description),
        HlsPackage: output.hlsPackage !== undefined && output.hlsPackage !== null
            ? deserializeAws_restJson1HlsPackage(output.hlsPackage, context)
            : undefined,
        Id: (0, smithy_client_1.expectString)(output.id),
        ManifestName: (0, smithy_client_1.expectString)(output.manifestName),
        MssPackage: output.mssPackage !== undefined && output.mssPackage !== null
            ? deserializeAws_restJson1MssPackage(output.mssPackage, context)
            : undefined,
        Origination: (0, smithy_client_1.expectString)(output.origination),
        StartoverWindowSeconds: (0, smithy_client_1.expectInt32)(output.startoverWindowSeconds),
        Tags: output.tags !== undefined && output.tags !== null
            ? deserializeAws_restJson1Tags(output.tags, context)
            : undefined,
        TimeDelaySeconds: (0, smithy_client_1.expectInt32)(output.timeDelaySeconds),
        Url: (0, smithy_client_1.expectString)(output.url),
        Whitelist: output.whitelist !== undefined && output.whitelist !== null
            ? deserializeAws_restJson1__listOf__string(output.whitelist, context)
            : undefined,
    };
};
const deserializeAws_restJson1S3Destination = (output, context) => {
    return {
        BucketName: (0, smithy_client_1.expectString)(output.bucketName),
        ManifestKey: (0, smithy_client_1.expectString)(output.manifestKey),
        RoleArn: (0, smithy_client_1.expectString)(output.roleArn),
    };
};
const deserializeAws_restJson1SpekeKeyProvider = (output, context) => {
    return {
        CertificateArn: (0, smithy_client_1.expectString)(output.certificateArn),
        EncryptionContractConfiguration: output.encryptionContractConfiguration !== undefined && output.encryptionContractConfiguration !== null
            ? deserializeAws_restJson1EncryptionContractConfiguration(output.encryptionContractConfiguration, context)
            : undefined,
        ResourceId: (0, smithy_client_1.expectString)(output.resourceId),
        RoleArn: (0, smithy_client_1.expectString)(output.roleArn),
        SystemIds: output.systemIds !== undefined && output.systemIds !== null
            ? deserializeAws_restJson1__listOf__string(output.systemIds, context)
            : undefined,
        Url: (0, smithy_client_1.expectString)(output.url),
    };
};
const deserializeAws_restJson1StreamSelection = (output, context) => {
    return {
        MaxVideoBitsPerSecond: (0, smithy_client_1.expectInt32)(output.maxVideoBitsPerSecond),
        MinVideoBitsPerSecond: (0, smithy_client_1.expectInt32)(output.minVideoBitsPerSecond),
        StreamOrder: (0, smithy_client_1.expectString)(output.streamOrder),
    };
};
const deserializeAws_restJson1Tags = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
