import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ConfigureLogsRequest, ConfigureLogsResponse } from "../models/models_0";
import { deserializeAws_restJson1ConfigureLogsCommand, serializeAws_restJson1ConfigureLogsCommand, } from "../protocols/Aws_restJson1";
var ConfigureLogsCommand = (function (_super) {
    __extends(ConfigureLogsCommand, _super);
    function ConfigureLogsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ConfigureLogsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "ConfigureLogsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ConfigureLogsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ConfigureLogsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ConfigureLogsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ConfigureLogsCommand(input, context);
    };
    ConfigureLogsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ConfigureLogsCommand(output, context);
    };
    return ConfigureLogsCommand;
}($Command));
export { ConfigureLogsCommand };
