import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateHarvestJobRequest, CreateHarvestJobResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateHarvestJobCommand, serializeAws_restJson1CreateHarvestJobCommand, } from "../protocols/Aws_restJson1";
var CreateHarvestJobCommand = (function (_super) {
    __extends(CreateHarvestJobCommand, _super);
    function CreateHarvestJobCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateHarvestJobCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "CreateHarvestJobCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateHarvestJobRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateHarvestJobResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateHarvestJobCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateHarvestJobCommand(input, context);
    };
    CreateHarvestJobCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateHarvestJobCommand(output, context);
    };
    return CreateHarvestJobCommand;
}($Command));
export { CreateHarvestJobCommand };
