import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateOriginEndpointRequest, CreateOriginEndpointResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateOriginEndpointCommand, serializeAws_restJson1CreateOriginEndpointCommand, } from "../protocols/Aws_restJson1";
var CreateOriginEndpointCommand = (function (_super) {
    __extends(CreateOriginEndpointCommand, _super);
    function CreateOriginEndpointCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateOriginEndpointCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "CreateOriginEndpointCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateOriginEndpointRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateOriginEndpointResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateOriginEndpointCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateOriginEndpointCommand(input, context);
    };
    CreateOriginEndpointCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateOriginEndpointCommand(output, context);
    };
    return CreateOriginEndpointCommand;
}($Command));
export { CreateOriginEndpointCommand };
