import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteOriginEndpointRequest, DeleteOriginEndpointResponse } from "../models/models_0";
import { deserializeAws_restJson1DeleteOriginEndpointCommand, serializeAws_restJson1DeleteOriginEndpointCommand, } from "../protocols/Aws_restJson1";
var DeleteOriginEndpointCommand = (function (_super) {
    __extends(DeleteOriginEndpointCommand, _super);
    function DeleteOriginEndpointCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteOriginEndpointCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "DeleteOriginEndpointCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteOriginEndpointRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteOriginEndpointResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteOriginEndpointCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteOriginEndpointCommand(input, context);
    };
    DeleteOriginEndpointCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteOriginEndpointCommand(output, context);
    };
    return DeleteOriginEndpointCommand;
}($Command));
export { DeleteOriginEndpointCommand };
