import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeChannelRequest, DescribeChannelResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeChannelCommand, serializeAws_restJson1DescribeChannelCommand, } from "../protocols/Aws_restJson1";
var DescribeChannelCommand = (function (_super) {
    __extends(DescribeChannelCommand, _super);
    function DescribeChannelCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeChannelCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "DescribeChannelCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeChannelRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeChannelResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeChannelCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeChannelCommand(input, context);
    };
    DescribeChannelCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeChannelCommand(output, context);
    };
    return DescribeChannelCommand;
}($Command));
export { DescribeChannelCommand };
