import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeHarvestJobRequest, DescribeHarvestJobResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeHarvestJobCommand, serializeAws_restJson1DescribeHarvestJobCommand, } from "../protocols/Aws_restJson1";
var DescribeHarvestJobCommand = (function (_super) {
    __extends(DescribeHarvestJobCommand, _super);
    function DescribeHarvestJobCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeHarvestJobCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "DescribeHarvestJobCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeHarvestJobRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeHarvestJobResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeHarvestJobCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeHarvestJobCommand(input, context);
    };
    DescribeHarvestJobCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeHarvestJobCommand(output, context);
    };
    return DescribeHarvestJobCommand;
}($Command));
export { DescribeHarvestJobCommand };
