import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RotateChannelCredentialsRequest, RotateChannelCredentialsResponse } from "../models/models_0";
import { deserializeAws_restJson1RotateChannelCredentialsCommand, serializeAws_restJson1RotateChannelCredentialsCommand, } from "../protocols/Aws_restJson1";
var RotateChannelCredentialsCommand = (function (_super) {
    __extends(RotateChannelCredentialsCommand, _super);
    function RotateChannelCredentialsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RotateChannelCredentialsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "RotateChannelCredentialsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RotateChannelCredentialsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: RotateChannelCredentialsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RotateChannelCredentialsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1RotateChannelCredentialsCommand(input, context);
    };
    RotateChannelCredentialsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1RotateChannelCredentialsCommand(output, context);
    };
    return RotateChannelCredentialsCommand;
}($Command));
export { RotateChannelCredentialsCommand };
