import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RotateIngestEndpointCredentialsRequest, RotateIngestEndpointCredentialsResponse } from "../models/models_0";
import { deserializeAws_restJson1RotateIngestEndpointCredentialsCommand, serializeAws_restJson1RotateIngestEndpointCredentialsCommand, } from "../protocols/Aws_restJson1";
var RotateIngestEndpointCredentialsCommand = (function (_super) {
    __extends(RotateIngestEndpointCredentialsCommand, _super);
    function RotateIngestEndpointCredentialsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RotateIngestEndpointCredentialsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "RotateIngestEndpointCredentialsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RotateIngestEndpointCredentialsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: RotateIngestEndpointCredentialsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RotateIngestEndpointCredentialsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1RotateIngestEndpointCredentialsCommand(input, context);
    };
    RotateIngestEndpointCredentialsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1RotateIngestEndpointCredentialsCommand(output, context);
    };
    return RotateIngestEndpointCredentialsCommand;
}($Command));
export { RotateIngestEndpointCredentialsCommand };
