import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateOriginEndpointRequest, UpdateOriginEndpointResponse } from "../models/models_0";
import { deserializeAws_restJson1UpdateOriginEndpointCommand, serializeAws_restJson1UpdateOriginEndpointCommand, } from "../protocols/Aws_restJson1";
var UpdateOriginEndpointCommand = (function (_super) {
    __extends(UpdateOriginEndpointCommand, _super);
    function UpdateOriginEndpointCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateOriginEndpointCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MediaPackageClient";
        var commandName = "UpdateOriginEndpointCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateOriginEndpointRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateOriginEndpointResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateOriginEndpointCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpdateOriginEndpointCommand(input, context);
    };
    UpdateOriginEndpointCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpdateOriginEndpointCommand(output, context);
    };
    return UpdateOriginEndpointCommand;
}($Command));
export { UpdateOriginEndpointCommand };
