import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { CreateHarvestJobRequest, CreateHarvestJobResponse } from "../models/models_0";
export interface CreateHarvestJobCommandInput extends CreateHarvestJobRequest {
}
export interface CreateHarvestJobCommandOutput extends CreateHarvestJobResponse, __MetadataBearer {
}

export declare class CreateHarvestJobCommand extends $Command<CreateHarvestJobCommandInput, CreateHarvestJobCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: CreateHarvestJobCommandInput;
    constructor(input: CreateHarvestJobCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateHarvestJobCommandInput, CreateHarvestJobCommandOutput>;
    private serialize;
    private deserialize;
}
