import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { CreateOriginEndpointRequest, CreateOriginEndpointResponse } from "../models/models_0";
export interface CreateOriginEndpointCommandInput extends CreateOriginEndpointRequest {
}
export interface CreateOriginEndpointCommandOutput extends CreateOriginEndpointResponse, __MetadataBearer {
}

export declare class CreateOriginEndpointCommand extends $Command<CreateOriginEndpointCommandInput, CreateOriginEndpointCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: CreateOriginEndpointCommandInput;
    constructor(input: CreateOriginEndpointCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateOriginEndpointCommandInput, CreateOriginEndpointCommandOutput>;
    private serialize;
    private deserialize;
}
