import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { DeleteChannelRequest, DeleteChannelResponse } from "../models/models_0";
export interface DeleteChannelCommandInput extends DeleteChannelRequest {
}
export interface DeleteChannelCommandOutput extends DeleteChannelResponse, __MetadataBearer {
}

export declare class DeleteChannelCommand extends $Command<DeleteChannelCommandInput, DeleteChannelCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: DeleteChannelCommandInput;
    constructor(input: DeleteChannelCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteChannelCommandInput, DeleteChannelCommandOutput>;
    private serialize;
    private deserialize;
}
