import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { DeleteOriginEndpointRequest, DeleteOriginEndpointResponse } from "../models/models_0";
export interface DeleteOriginEndpointCommandInput extends DeleteOriginEndpointRequest {
}
export interface DeleteOriginEndpointCommandOutput extends DeleteOriginEndpointResponse, __MetadataBearer {
}

export declare class DeleteOriginEndpointCommand extends $Command<DeleteOriginEndpointCommandInput, DeleteOriginEndpointCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: DeleteOriginEndpointCommandInput;
    constructor(input: DeleteOriginEndpointCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteOriginEndpointCommandInput, DeleteOriginEndpointCommandOutput>;
    private serialize;
    private deserialize;
}
