import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { DescribeHarvestJobRequest, DescribeHarvestJobResponse } from "../models/models_0";
export interface DescribeHarvestJobCommandInput extends DescribeHarvestJobRequest {
}
export interface DescribeHarvestJobCommandOutput extends DescribeHarvestJobResponse, __MetadataBearer {
}

export declare class DescribeHarvestJobCommand extends $Command<DescribeHarvestJobCommandInput, DescribeHarvestJobCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: DescribeHarvestJobCommandInput;
    constructor(input: DescribeHarvestJobCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeHarvestJobCommandInput, DescribeHarvestJobCommandOutput>;
    private serialize;
    private deserialize;
}
