import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { DescribeOriginEndpointRequest, DescribeOriginEndpointResponse } from "../models/models_0";
export interface DescribeOriginEndpointCommandInput extends DescribeOriginEndpointRequest {
}
export interface DescribeOriginEndpointCommandOutput extends DescribeOriginEndpointResponse, __MetadataBearer {
}

export declare class DescribeOriginEndpointCommand extends $Command<DescribeOriginEndpointCommandInput, DescribeOriginEndpointCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: DescribeOriginEndpointCommandInput;
    constructor(input: DescribeOriginEndpointCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeOriginEndpointCommandInput, DescribeOriginEndpointCommandOutput>;
    private serialize;
    private deserialize;
}
