import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { ListHarvestJobsRequest, ListHarvestJobsResponse } from "../models/models_0";
export interface ListHarvestJobsCommandInput extends ListHarvestJobsRequest {
}
export interface ListHarvestJobsCommandOutput extends ListHarvestJobsResponse, __MetadataBearer {
}

export declare class ListHarvestJobsCommand extends $Command<ListHarvestJobsCommandInput, ListHarvestJobsCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: ListHarvestJobsCommandInput;
    constructor(input: ListHarvestJobsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListHarvestJobsCommandInput, ListHarvestJobsCommandOutput>;
    private serialize;
    private deserialize;
}
