import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { ListOriginEndpointsRequest, ListOriginEndpointsResponse } from "../models/models_0";
export interface ListOriginEndpointsCommandInput extends ListOriginEndpointsRequest {
}
export interface ListOriginEndpointsCommandOutput extends ListOriginEndpointsResponse, __MetadataBearer {
}

export declare class ListOriginEndpointsCommand extends $Command<ListOriginEndpointsCommandInput, ListOriginEndpointsCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: ListOriginEndpointsCommandInput;
    constructor(input: ListOriginEndpointsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListOriginEndpointsCommandInput, ListOriginEndpointsCommandOutput>;
    private serialize;
    private deserialize;
}
