import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MediaPackageClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MediaPackageClient";
import { RotateChannelCredentialsRequest, RotateChannelCredentialsResponse } from "../models/models_0";
export interface RotateChannelCredentialsCommandInput extends RotateChannelCredentialsRequest {
}
export interface RotateChannelCredentialsCommandOutput extends RotateChannelCredentialsResponse, __MetadataBearer {
}

export declare class RotateChannelCredentialsCommand extends $Command<RotateChannelCredentialsCommandInput, RotateChannelCredentialsCommandOutput, MediaPackageClientResolvedConfig> {
    readonly input: RotateChannelCredentialsCommandInput;
    constructor(input: RotateChannelCredentialsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MediaPackageClientResolvedConfig, options?: __HttpHandlerOptions): Handler<RotateChannelCredentialsCommandInput, RotateChannelCredentialsCommandOutput>;
    private serialize;
    private deserialize;
}
