import { ExceptionOptionType as __ExceptionOptionType } from "@aws-sdk/smithy-client";
import { MediaPackageServiceException as __BaseException } from "./MediaPackageServiceException";
export declare enum __AdTriggersElement {
    BREAK = "BREAK",
    DISTRIBUTOR_ADVERTISEMENT = "DISTRIBUTOR_ADVERTISEMENT",
    DISTRIBUTOR_OVERLAY_PLACEMENT_OPPORTUNITY = "DISTRIBUTOR_OVERLAY_PLACEMENT_OPPORTUNITY",
    DISTRIBUTOR_PLACEMENT_OPPORTUNITY = "DISTRIBUTOR_PLACEMENT_OPPORTUNITY",
    PROVIDER_ADVERTISEMENT = "PROVIDER_ADVERTISEMENT",
    PROVIDER_OVERLAY_PLACEMENT_OPPORTUNITY = "PROVIDER_OVERLAY_PLACEMENT_OPPORTUNITY",
    PROVIDER_PLACEMENT_OPPORTUNITY = "PROVIDER_PLACEMENT_OPPORTUNITY",
    SPLICE_INSERT = "SPLICE_INSERT"
}
export declare enum __PeriodTriggersElement {
    ADS = "ADS"
}

export interface EgressAccessLogs {
    
    LogGroupName?: string;
}
export declare namespace EgressAccessLogs {
    
    const filterSensitiveLog: (obj: EgressAccessLogs) => any;
}

export interface IngestEndpoint {
    
    Id?: string;
    
    Password?: string;
    
    Url?: string;
    
    Username?: string;
}
export declare namespace IngestEndpoint {
    
    const filterSensitiveLog: (obj: IngestEndpoint) => any;
}

export interface HlsIngest {
    
    IngestEndpoints?: IngestEndpoint[];
}
export declare namespace HlsIngest {
    
    const filterSensitiveLog: (obj: HlsIngest) => any;
}

export interface IngressAccessLogs {
    
    LogGroupName?: string;
}
export declare namespace IngressAccessLogs {
    
    const filterSensitiveLog: (obj: IngressAccessLogs) => any;
}

export interface Channel {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace Channel {
    
    const filterSensitiveLog: (obj: Channel) => any;
}

export interface S3Destination {
    
    BucketName: string | undefined;
    
    ManifestKey: string | undefined;
    
    RoleArn: string | undefined;
}
export declare namespace S3Destination {
    
    const filterSensitiveLog: (obj: S3Destination) => any;
}
export declare enum Status {
    FAILED = "FAILED",
    IN_PROGRESS = "IN_PROGRESS",
    SUCCEEDED = "SUCCEEDED"
}

export interface HarvestJob {
    
    Arn?: string;
    
    ChannelId?: string;
    
    CreatedAt?: string;
    
    EndTime?: string;
    
    Id?: string;
    
    OriginEndpointId?: string;
    
    S3Destination?: S3Destination;
    
    StartTime?: string;
    
    Status?: Status | string;
}
export declare namespace HarvestJob {
    
    const filterSensitiveLog: (obj: HarvestJob) => any;
}
export declare enum AdMarkers {
    DATERANGE = "DATERANGE",
    NONE = "NONE",
    PASSTHROUGH = "PASSTHROUGH",
    SCTE35_ENHANCED = "SCTE35_ENHANCED"
}
export declare enum PlaylistType {
    EVENT = "EVENT",
    NONE = "NONE",
    VOD = "VOD"
}

export interface HlsManifest {
    
    AdMarkers?: AdMarkers | string;
    
    Id: string | undefined;
    
    IncludeIframeOnlyStream?: boolean;
    
    ManifestName?: string;
    
    PlaylistType?: PlaylistType | string;
    
    PlaylistWindowSeconds?: number;
    
    ProgramDateTimeIntervalSeconds?: number;
    
    Url?: string;
}
export declare namespace HlsManifest {
    
    const filterSensitiveLog: (obj: HlsManifest) => any;
}
export declare enum AdsOnDeliveryRestrictions {
    BOTH = "BOTH",
    NONE = "NONE",
    RESTRICTED = "RESTRICTED",
    UNRESTRICTED = "UNRESTRICTED"
}

export interface HlsManifestCreateOrUpdateParameters {
    
    AdMarkers?: AdMarkers | string;
    
    AdTriggers?: (__AdTriggersElement | string)[];
    
    AdsOnDeliveryRestrictions?: AdsOnDeliveryRestrictions | string;
    
    Id: string | undefined;
    
    IncludeIframeOnlyStream?: boolean;
    
    ManifestName?: string;
    
    PlaylistType?: PlaylistType | string;
    
    PlaylistWindowSeconds?: number;
    
    ProgramDateTimeIntervalSeconds?: number;
}
export declare namespace HlsManifestCreateOrUpdateParameters {
    
    const filterSensitiveLog: (obj: HlsManifestCreateOrUpdateParameters) => any;
}

export interface Authorization {
    
    CdnIdentifierSecret: string | undefined;
    
    SecretsRoleArn: string | undefined;
}
export declare namespace Authorization {
    
    const filterSensitiveLog: (obj: Authorization) => any;
}
export declare enum PresetSpeke20Audio {
    PRESET_AUDIO_1 = "PRESET-AUDIO-1"
}
export declare enum PresetSpeke20Video {
    PRESET_VIDEO_1 = "PRESET-VIDEO-1"
}

export interface EncryptionContractConfiguration {
    
    PresetSpeke20Audio: PresetSpeke20Audio | string | undefined;
    
    PresetSpeke20Video: PresetSpeke20Video | string | undefined;
}
export declare namespace EncryptionContractConfiguration {
    
    const filterSensitiveLog: (obj: EncryptionContractConfiguration) => any;
}

export interface SpekeKeyProvider {
    
    CertificateArn?: string;
    
    EncryptionContractConfiguration?: EncryptionContractConfiguration;
    
    ResourceId: string | undefined;
    
    RoleArn: string | undefined;
    
    SystemIds: string[] | undefined;
    
    Url: string | undefined;
}
export declare namespace SpekeKeyProvider {
    
    const filterSensitiveLog: (obj: SpekeKeyProvider) => any;
}

export interface CmafEncryption {
    
    ConstantInitializationVector?: string;
    
    KeyRotationIntervalSeconds?: number;
    
    SpekeKeyProvider: SpekeKeyProvider | undefined;
}
export declare namespace CmafEncryption {
    
    const filterSensitiveLog: (obj: CmafEncryption) => any;
}
export declare enum StreamOrder {
    ORIGINAL = "ORIGINAL",
    VIDEO_BITRATE_ASCENDING = "VIDEO_BITRATE_ASCENDING",
    VIDEO_BITRATE_DESCENDING = "VIDEO_BITRATE_DESCENDING"
}

export interface StreamSelection {
    
    MaxVideoBitsPerSecond?: number;
    
    MinVideoBitsPerSecond?: number;
    
    StreamOrder?: StreamOrder | string;
}
export declare namespace StreamSelection {
    
    const filterSensitiveLog: (obj: StreamSelection) => any;
}

export interface CmafPackage {
    
    Encryption?: CmafEncryption;
    
    HlsManifests?: HlsManifest[];
    
    SegmentDurationSeconds?: number;
    
    SegmentPrefix?: string;
    
    StreamSelection?: StreamSelection;
}
export declare namespace CmafPackage {
    
    const filterSensitiveLog: (obj: CmafPackage) => any;
}

export interface DashEncryption {
    
    KeyRotationIntervalSeconds?: number;
    
    SpekeKeyProvider: SpekeKeyProvider | undefined;
}
export declare namespace DashEncryption {
    
    const filterSensitiveLog: (obj: DashEncryption) => any;
}
export declare enum ManifestLayout {
    COMPACT = "COMPACT",
    FULL = "FULL"
}
export declare enum Profile {
    HBBTV_1_5 = "HBBTV_1_5",
    HYBRIDCAST = "HYBRIDCAST",
    NONE = "NONE"
}
export declare enum SegmentTemplateFormat {
    NUMBER_WITH_DURATION = "NUMBER_WITH_DURATION",
    NUMBER_WITH_TIMELINE = "NUMBER_WITH_TIMELINE",
    TIME_WITH_TIMELINE = "TIME_WITH_TIMELINE"
}
export declare enum UtcTiming {
    HTTP_HEAD = "HTTP-HEAD",
    HTTP_ISO = "HTTP-ISO",
    NONE = "NONE"
}

export interface DashPackage {
    
    AdTriggers?: (__AdTriggersElement | string)[];
    
    AdsOnDeliveryRestrictions?: AdsOnDeliveryRestrictions | string;
    
    Encryption?: DashEncryption;
    
    ManifestLayout?: ManifestLayout | string;
    
    ManifestWindowSeconds?: number;
    
    MinBufferTimeSeconds?: number;
    
    MinUpdatePeriodSeconds?: number;
    
    PeriodTriggers?: (__PeriodTriggersElement | string)[];
    
    Profile?: Profile | string;
    
    SegmentDurationSeconds?: number;
    
    SegmentTemplateFormat?: SegmentTemplateFormat | string;
    
    StreamSelection?: StreamSelection;
    
    SuggestedPresentationDelaySeconds?: number;
    
    UtcTiming?: UtcTiming | string;
    
    UtcTimingUri?: string;
}
export declare namespace DashPackage {
    
    const filterSensitiveLog: (obj: DashPackage) => any;
}
export declare enum EncryptionMethod {
    AES_128 = "AES_128",
    SAMPLE_AES = "SAMPLE_AES"
}

export interface HlsEncryption {
    
    ConstantInitializationVector?: string;
    
    EncryptionMethod?: EncryptionMethod | string;
    
    KeyRotationIntervalSeconds?: number;
    
    RepeatExtXKey?: boolean;
    
    SpekeKeyProvider: SpekeKeyProvider | undefined;
}
export declare namespace HlsEncryption {
    
    const filterSensitiveLog: (obj: HlsEncryption) => any;
}

export interface HlsPackage {
    
    AdMarkers?: AdMarkers | string;
    
    AdTriggers?: (__AdTriggersElement | string)[];
    
    AdsOnDeliveryRestrictions?: AdsOnDeliveryRestrictions | string;
    
    Encryption?: HlsEncryption;
    
    IncludeDvbSubtitles?: boolean;
    
    IncludeIframeOnlyStream?: boolean;
    
    PlaylistType?: PlaylistType | string;
    
    PlaylistWindowSeconds?: number;
    
    ProgramDateTimeIntervalSeconds?: number;
    
    SegmentDurationSeconds?: number;
    
    StreamSelection?: StreamSelection;
    
    UseAudioRenditionGroup?: boolean;
}
export declare namespace HlsPackage {
    
    const filterSensitiveLog: (obj: HlsPackage) => any;
}

export interface MssEncryption {
    
    SpekeKeyProvider: SpekeKeyProvider | undefined;
}
export declare namespace MssEncryption {
    
    const filterSensitiveLog: (obj: MssEncryption) => any;
}

export interface MssPackage {
    
    Encryption?: MssEncryption;
    
    ManifestWindowSeconds?: number;
    
    SegmentDurationSeconds?: number;
    
    StreamSelection?: StreamSelection;
}
export declare namespace MssPackage {
    
    const filterSensitiveLog: (obj: MssPackage) => any;
}
export declare enum Origination {
    ALLOW = "ALLOW",
    DENY = "DENY"
}

export interface OriginEndpoint {
    
    Arn?: string;
    
    Authorization?: Authorization;
    
    ChannelId?: string;
    
    CmafPackage?: CmafPackage;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id?: string;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    Tags?: {
        [key: string]: string;
    };
    
    TimeDelaySeconds?: number;
    
    Url?: string;
    
    Whitelist?: string[];
}
export declare namespace OriginEndpoint {
    
    const filterSensitiveLog: (obj: OriginEndpoint) => any;
}

export interface CmafPackageCreateOrUpdateParameters {
    
    Encryption?: CmafEncryption;
    
    HlsManifests?: HlsManifestCreateOrUpdateParameters[];
    
    SegmentDurationSeconds?: number;
    
    SegmentPrefix?: string;
    
    StreamSelection?: StreamSelection;
}
export declare namespace CmafPackageCreateOrUpdateParameters {
    
    const filterSensitiveLog: (obj: CmafPackageCreateOrUpdateParameters) => any;
}

export interface ConfigureLogsRequest {
    
    EgressAccessLogs?: EgressAccessLogs;
    
    Id: string | undefined;
    
    IngressAccessLogs?: IngressAccessLogs;
}
export declare namespace ConfigureLogsRequest {
    
    const filterSensitiveLog: (obj: ConfigureLogsRequest) => any;
}
export interface ConfigureLogsResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace ConfigureLogsResponse {
    
    const filterSensitiveLog: (obj: ConfigureLogsResponse) => any;
}

export declare class ForbiddenException extends __BaseException {
    readonly name: "ForbiddenException";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<ForbiddenException, __BaseException>);
}

export declare class InternalServerErrorException extends __BaseException {
    readonly name: "InternalServerErrorException";
    readonly $fault: "server";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<InternalServerErrorException, __BaseException>);
}

export declare class NotFoundException extends __BaseException {
    readonly name: "NotFoundException";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<NotFoundException, __BaseException>);
}

export declare class ServiceUnavailableException extends __BaseException {
    readonly name: "ServiceUnavailableException";
    readonly $fault: "server";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<ServiceUnavailableException, __BaseException>);
}

export declare class TooManyRequestsException extends __BaseException {
    readonly name: "TooManyRequestsException";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<TooManyRequestsException, __BaseException>);
}

export declare class UnprocessableEntityException extends __BaseException {
    readonly name: "UnprocessableEntityException";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<UnprocessableEntityException, __BaseException>);
}

export interface CreateChannelRequest {
    
    Description?: string;
    
    Id: string | undefined;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace CreateChannelRequest {
    
    const filterSensitiveLog: (obj: CreateChannelRequest) => any;
}
export interface CreateChannelResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace CreateChannelResponse {
    
    const filterSensitiveLog: (obj: CreateChannelResponse) => any;
}

export interface CreateHarvestJobRequest {
    
    EndTime: string | undefined;
    
    Id: string | undefined;
    
    OriginEndpointId: string | undefined;
    
    S3Destination: S3Destination | undefined;
    
    StartTime: string | undefined;
}
export declare namespace CreateHarvestJobRequest {
    
    const filterSensitiveLog: (obj: CreateHarvestJobRequest) => any;
}
export interface CreateHarvestJobResponse {
    
    Arn?: string;
    
    ChannelId?: string;
    
    CreatedAt?: string;
    
    EndTime?: string;
    
    Id?: string;
    
    OriginEndpointId?: string;
    
    S3Destination?: S3Destination;
    
    StartTime?: string;
    
    Status?: Status | string;
}
export declare namespace CreateHarvestJobResponse {
    
    const filterSensitiveLog: (obj: CreateHarvestJobResponse) => any;
}

export interface CreateOriginEndpointRequest {
    
    Authorization?: Authorization;
    
    ChannelId: string | undefined;
    
    CmafPackage?: CmafPackageCreateOrUpdateParameters;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id: string | undefined;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    Tags?: {
        [key: string]: string;
    };
    
    TimeDelaySeconds?: number;
    
    Whitelist?: string[];
}
export declare namespace CreateOriginEndpointRequest {
    
    const filterSensitiveLog: (obj: CreateOriginEndpointRequest) => any;
}
export interface CreateOriginEndpointResponse {
    
    Arn?: string;
    
    Authorization?: Authorization;
    
    ChannelId?: string;
    
    CmafPackage?: CmafPackage;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id?: string;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    Tags?: {
        [key: string]: string;
    };
    
    TimeDelaySeconds?: number;
    
    Url?: string;
    
    Whitelist?: string[];
}
export declare namespace CreateOriginEndpointResponse {
    
    const filterSensitiveLog: (obj: CreateOriginEndpointResponse) => any;
}
export interface DeleteChannelRequest {
    
    Id: string | undefined;
}
export declare namespace DeleteChannelRequest {
    
    const filterSensitiveLog: (obj: DeleteChannelRequest) => any;
}
export interface DeleteChannelResponse {
}
export declare namespace DeleteChannelResponse {
    
    const filterSensitiveLog: (obj: DeleteChannelResponse) => any;
}
export interface DeleteOriginEndpointRequest {
    
    Id: string | undefined;
}
export declare namespace DeleteOriginEndpointRequest {
    
    const filterSensitiveLog: (obj: DeleteOriginEndpointRequest) => any;
}
export interface DeleteOriginEndpointResponse {
}
export declare namespace DeleteOriginEndpointResponse {
    
    const filterSensitiveLog: (obj: DeleteOriginEndpointResponse) => any;
}
export interface DescribeChannelRequest {
    
    Id: string | undefined;
}
export declare namespace DescribeChannelRequest {
    
    const filterSensitiveLog: (obj: DescribeChannelRequest) => any;
}
export interface DescribeChannelResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace DescribeChannelResponse {
    
    const filterSensitiveLog: (obj: DescribeChannelResponse) => any;
}
export interface DescribeHarvestJobRequest {
    
    Id: string | undefined;
}
export declare namespace DescribeHarvestJobRequest {
    
    const filterSensitiveLog: (obj: DescribeHarvestJobRequest) => any;
}
export interface DescribeHarvestJobResponse {
    
    Arn?: string;
    
    ChannelId?: string;
    
    CreatedAt?: string;
    
    EndTime?: string;
    
    Id?: string;
    
    OriginEndpointId?: string;
    
    S3Destination?: S3Destination;
    
    StartTime?: string;
    
    Status?: Status | string;
}
export declare namespace DescribeHarvestJobResponse {
    
    const filterSensitiveLog: (obj: DescribeHarvestJobResponse) => any;
}
export interface DescribeOriginEndpointRequest {
    
    Id: string | undefined;
}
export declare namespace DescribeOriginEndpointRequest {
    
    const filterSensitiveLog: (obj: DescribeOriginEndpointRequest) => any;
}
export interface DescribeOriginEndpointResponse {
    
    Arn?: string;
    
    Authorization?: Authorization;
    
    ChannelId?: string;
    
    CmafPackage?: CmafPackage;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id?: string;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    Tags?: {
        [key: string]: string;
    };
    
    TimeDelaySeconds?: number;
    
    Url?: string;
    
    Whitelist?: string[];
}
export declare namespace DescribeOriginEndpointResponse {
    
    const filterSensitiveLog: (obj: DescribeOriginEndpointResponse) => any;
}
export interface ListChannelsRequest {
    
    MaxResults?: number;
    
    NextToken?: string;
}
export declare namespace ListChannelsRequest {
    
    const filterSensitiveLog: (obj: ListChannelsRequest) => any;
}
export interface ListChannelsResponse {
    
    Channels?: Channel[];
    
    NextToken?: string;
}
export declare namespace ListChannelsResponse {
    
    const filterSensitiveLog: (obj: ListChannelsResponse) => any;
}
export interface ListHarvestJobsRequest {
    
    IncludeChannelId?: string;
    
    IncludeStatus?: string;
    
    MaxResults?: number;
    
    NextToken?: string;
}
export declare namespace ListHarvestJobsRequest {
    
    const filterSensitiveLog: (obj: ListHarvestJobsRequest) => any;
}
export interface ListHarvestJobsResponse {
    
    HarvestJobs?: HarvestJob[];
    
    NextToken?: string;
}
export declare namespace ListHarvestJobsResponse {
    
    const filterSensitiveLog: (obj: ListHarvestJobsResponse) => any;
}
export interface ListOriginEndpointsRequest {
    
    ChannelId?: string;
    
    MaxResults?: number;
    
    NextToken?: string;
}
export declare namespace ListOriginEndpointsRequest {
    
    const filterSensitiveLog: (obj: ListOriginEndpointsRequest) => any;
}
export interface ListOriginEndpointsResponse {
    
    NextToken?: string;
    
    OriginEndpoints?: OriginEndpoint[];
}
export declare namespace ListOriginEndpointsResponse {
    
    const filterSensitiveLog: (obj: ListOriginEndpointsResponse) => any;
}
export interface ListTagsForResourceRequest {
    ResourceArn: string | undefined;
}
export declare namespace ListTagsForResourceRequest {
    
    const filterSensitiveLog: (obj: ListTagsForResourceRequest) => any;
}
export interface ListTagsForResourceResponse {
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace ListTagsForResourceResponse {
    
    const filterSensitiveLog: (obj: ListTagsForResourceResponse) => any;
}
export interface RotateChannelCredentialsRequest {
    
    Id: string | undefined;
}
export declare namespace RotateChannelCredentialsRequest {
    
    const filterSensitiveLog: (obj: RotateChannelCredentialsRequest) => any;
}
export interface RotateChannelCredentialsResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace RotateChannelCredentialsResponse {
    
    const filterSensitiveLog: (obj: RotateChannelCredentialsResponse) => any;
}
export interface RotateIngestEndpointCredentialsRequest {
    
    Id: string | undefined;
    
    IngestEndpointId: string | undefined;
}
export declare namespace RotateIngestEndpointCredentialsRequest {
    
    const filterSensitiveLog: (obj: RotateIngestEndpointCredentialsRequest) => any;
}
export interface RotateIngestEndpointCredentialsResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace RotateIngestEndpointCredentialsResponse {
    
    const filterSensitiveLog: (obj: RotateIngestEndpointCredentialsResponse) => any;
}
export interface TagResourceRequest {
    ResourceArn: string | undefined;
    Tags: {
        [key: string]: string;
    } | undefined;
}
export declare namespace TagResourceRequest {
    
    const filterSensitiveLog: (obj: TagResourceRequest) => any;
}
export interface UntagResourceRequest {
    ResourceArn: string | undefined;
    
    TagKeys: string[] | undefined;
}
export declare namespace UntagResourceRequest {
    
    const filterSensitiveLog: (obj: UntagResourceRequest) => any;
}

export interface UpdateChannelRequest {
    
    Description?: string;
    
    Id: string | undefined;
}
export declare namespace UpdateChannelRequest {
    
    const filterSensitiveLog: (obj: UpdateChannelRequest) => any;
}
export interface UpdateChannelResponse {
    
    Arn?: string;
    
    Description?: string;
    
    EgressAccessLogs?: EgressAccessLogs;
    
    HlsIngest?: HlsIngest;
    
    Id?: string;
    
    IngressAccessLogs?: IngressAccessLogs;
    
    Tags?: {
        [key: string]: string;
    };
}
export declare namespace UpdateChannelResponse {
    
    const filterSensitiveLog: (obj: UpdateChannelResponse) => any;
}

export interface UpdateOriginEndpointRequest {
    
    Authorization?: Authorization;
    
    CmafPackage?: CmafPackageCreateOrUpdateParameters;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id: string | undefined;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    TimeDelaySeconds?: number;
    
    Whitelist?: string[];
}
export declare namespace UpdateOriginEndpointRequest {
    
    const filterSensitiveLog: (obj: UpdateOriginEndpointRequest) => any;
}
export interface UpdateOriginEndpointResponse {
    
    Arn?: string;
    
    Authorization?: Authorization;
    
    ChannelId?: string;
    
    CmafPackage?: CmafPackage;
    
    DashPackage?: DashPackage;
    
    Description?: string;
    
    HlsPackage?: HlsPackage;
    
    Id?: string;
    
    ManifestName?: string;
    
    MssPackage?: MssPackage;
    
    Origination?: Origination | string;
    
    StartoverWindowSeconds?: number;
    
    Tags?: {
        [key: string]: string;
    };
    
    TimeDelaySeconds?: number;
    
    Url?: string;
    
    Whitelist?: string[];
}
export declare namespace UpdateOriginEndpointResponse {
    
    const filterSensitiveLog: (obj: UpdateOriginEndpointResponse) => any;
}
