import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { ConfigureLogsCommandInput, ConfigureLogsCommandOutput } from "../commands/ConfigureLogsCommand";
import { CreateChannelCommandInput, CreateChannelCommandOutput } from "../commands/CreateChannelCommand";
import { CreateHarvestJobCommandInput, CreateHarvestJobCommandOutput } from "../commands/CreateHarvestJobCommand";
import { CreateOriginEndpointCommandInput, CreateOriginEndpointCommandOutput } from "../commands/CreateOriginEndpointCommand";
import { DeleteChannelCommandInput, DeleteChannelCommandOutput } from "../commands/DeleteChannelCommand";
import { DeleteOriginEndpointCommandInput, DeleteOriginEndpointCommandOutput } from "../commands/DeleteOriginEndpointCommand";
import { DescribeChannelCommandInput, DescribeChannelCommandOutput } from "../commands/DescribeChannelCommand";
import { DescribeHarvestJobCommandInput, DescribeHarvestJobCommandOutput } from "../commands/DescribeHarvestJobCommand";
import { DescribeOriginEndpointCommandInput, DescribeOriginEndpointCommandOutput } from "../commands/DescribeOriginEndpointCommand";
import { ListChannelsCommandInput, ListChannelsCommandOutput } from "../commands/ListChannelsCommand";
import { ListHarvestJobsCommandInput, ListHarvestJobsCommandOutput } from "../commands/ListHarvestJobsCommand";
import { ListOriginEndpointsCommandInput, ListOriginEndpointsCommandOutput } from "../commands/ListOriginEndpointsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { RotateChannelCredentialsCommandInput, RotateChannelCredentialsCommandOutput } from "../commands/RotateChannelCredentialsCommand";
import { RotateIngestEndpointCredentialsCommandInput, RotateIngestEndpointCredentialsCommandOutput } from "../commands/RotateIngestEndpointCredentialsCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateChannelCommandInput, UpdateChannelCommandOutput } from "../commands/UpdateChannelCommand";
import { UpdateOriginEndpointCommandInput, UpdateOriginEndpointCommandOutput } from "../commands/UpdateOriginEndpointCommand";
export declare const serializeAws_restJson1ConfigureLogsCommand: (input: ConfigureLogsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateChannelCommand: (input: CreateChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateHarvestJobCommand: (input: CreateHarvestJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateOriginEndpointCommand: (input: CreateOriginEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteChannelCommand: (input: DeleteChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteOriginEndpointCommand: (input: DeleteOriginEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeChannelCommand: (input: DescribeChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeHarvestJobCommand: (input: DescribeHarvestJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeOriginEndpointCommand: (input: DescribeOriginEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListChannelsCommand: (input: ListChannelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListHarvestJobsCommand: (input: ListHarvestJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListOriginEndpointsCommand: (input: ListOriginEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1RotateChannelCredentialsCommand: (input: RotateChannelCredentialsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1RotateIngestEndpointCredentialsCommand: (input: RotateIngestEndpointCredentialsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateChannelCommand: (input: UpdateChannelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateOriginEndpointCommand: (input: UpdateOriginEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1ConfigureLogsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ConfigureLogsCommandOutput>;
export declare const deserializeAws_restJson1CreateChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateChannelCommandOutput>;
export declare const deserializeAws_restJson1CreateHarvestJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateHarvestJobCommandOutput>;
export declare const deserializeAws_restJson1CreateOriginEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateOriginEndpointCommandOutput>;
export declare const deserializeAws_restJson1DeleteChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteChannelCommandOutput>;
export declare const deserializeAws_restJson1DeleteOriginEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteOriginEndpointCommandOutput>;
export declare const deserializeAws_restJson1DescribeChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeChannelCommandOutput>;
export declare const deserializeAws_restJson1DescribeHarvestJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeHarvestJobCommandOutput>;
export declare const deserializeAws_restJson1DescribeOriginEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeOriginEndpointCommandOutput>;
export declare const deserializeAws_restJson1ListChannelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListChannelsCommandOutput>;
export declare const deserializeAws_restJson1ListHarvestJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListHarvestJobsCommandOutput>;
export declare const deserializeAws_restJson1ListOriginEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListOriginEndpointsCommandOutput>;
export declare const deserializeAws_restJson1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_restJson1RotateChannelCredentialsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RotateChannelCredentialsCommandOutput>;
export declare const deserializeAws_restJson1RotateIngestEndpointCredentialsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RotateIngestEndpointCredentialsCommandOutput>;
export declare const deserializeAws_restJson1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_restJson1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
export declare const deserializeAws_restJson1UpdateChannelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateChannelCommandOutput>;
export declare const deserializeAws_restJson1UpdateOriginEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateOriginEndpointCommandOutput>;
